<template lang='pug'>
mixin prop(name)
  li #[strong.text-info= name+': ']
    block

Example(ref='example' title='ParamList & Select Example' :maxState="1")
  template(v-slot:description)
    h5 This is a ParamList and Select example
    p Click on the #[em animate] to toggle edit mode.
    p Click on #[em code] to view and modify its code.

  template(v-slot:interface)
    div #[strong Properties:]
      ul
        +prop("title") the title (ParamList only)
        +prop("value") the current live value
        +prop("options") an array of options (objects with text and value properties)
        +prop("inEdit") enter/exit edit mode

    div #[strong Data:]
      ul
        +prop("editValue") edit mode currently selected value

    div #[strong Computed:]
      ul
        +prop("valueText") text value associated with current value
        +prop("editValueText") text value associated with editValue

    div #[strong Signals:]
      ul
        +prop("edit") emitted whenever editValue is changed (with editValue new content)
        +prop("edit-request") emitted whenever the icon on the right is clicked while not in edit mode

  template(v-slot:code)
    template(v-pre).
      .row.justify-content-center.align-items-center.b-param-container
        BaseSelect.col-12.col-sm-6(value='2' :inEdit='state !== 0' @edit-request='state = state ? 0 : 1')
          template(v-slot:options='')
            option(value="1") first
            option(value="2") second
            option(value="3") last
        BaseSelect.col-12.col-sm-6(ref='dyn' :value='2' :inEdit='state !== 0'
                                  :options=`[ { value: 1, text: "first" },
                                    { value: 2, text: "second" },
                                    { value: 3, text: "last" } ]`)

        BaseParamList.col-12.col-sm-6(value='2' :inEdit='state !== 0'
                                  title='Static List'
                                  @edit-request='state = 1')
          template(v-slot:options='')
            option(value="1") first
            option(value="2") second
            option(value="3") last
        BaseParamList.col-12.col-sm-6(ref='dyn' :value='2' :inEdit='state !== 0'
                                  title='Dynamic List'
                                  :options=`[ { value: 1, text: "first" },
                                    { value: 2, text: "second" },
                                    { value: 3, text: "last" } ]`
                                  @edit-request='state = 1')
          template(v-slot:title='p')
            | \#[strong Dynamic List] (edit:{{ p.editValueText }})

</template>
<script>

import Example from "./AppExample.vue";

export default {
  name: "ExampleParamList",
  components: { Example }
};

</script>
